/******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***  LN - own implementation of a simple CUI program to create hardlinks.  ***
 ***  Symlinks (aka Reparse Points/Junction Points) will be implemented     ***
 ***  soon. Everything is already prepared for it.                          ***
 ***  The program is just a demo for the C/C++ module Hardlink.cpp          ***
 ***                                                                        ***
 ***  Version [1.00a]                               {Last mod 2005-04-10}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2005 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad @ gmx.info|.net|.com|.de  |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizni.    ***
 ***                     Vsekh Privet iz Germanii                           ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 NOTE: This source is OSI-licensed. You may choose between any of the licenses
       approved by the OSI (Open Source Initiative) as long as the licensing
       of this module will not force a whole project under the chosen license.
       This basically means that the virulent character of a license (e.g. GPL)
       must no be misused to force a project to use the license you chose for
       this module!
       OSI-approved licenses can be found at this website:
	   http://www.opensource.org/licenses/

       You have the choice to make this module compatible with your own open
       source or commercial or whatever project by choosing the right license.

       However, I recommend using either of the following licenses:
       - the BSD-License (as seen below)
       - the LGPL [ http://www.opensource.org/licenses/lgpl-license.php ]
       - the MPL [ http://www.opensource.org/licenses/mozilla1.1.php ]

       !ATTENTION!: if this unit comes bundled with the files of the project
       JEDI the project license (currently MPL) is mandatory!!!
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2005, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************/

#define _X86_
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <Shellapi.h>
#include <stdio.h>
#include "Hardlink.h"

#pragma optimize("gsy",on)

#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"shell32.lib")

// This defines whether the functions should be linked with the MSVCRT.DLL
// or whether the respective code should be contained in the EXE file.
#define USE_MSVCRT

#ifdef USE_MSVCRT
	#pragma comment(linker,"/defaultlib:msvcrt.lib")
	#pragma comment(lib,"msvcrt.lib")
	#pragma comment(linker,"/nodefaultlib:libc.lib")
	#pragma comment(linker, "-entry:main")
#else
	#pragma comment(lib,"libc.lib")
	#pragma comment(linker,"/nodefaultlib:msvcrt.lib")
#endif

#if (_MSC_VER<1300)
  #pragma comment(linker,"/RELEASE")
#endif
#pragma comment(linker, "/opt:nowin98")
#pragma comment(linker, "/opt:ref")
#pragma comment(linker, "/machine:IX86")
#pragma comment(linker, "/merge:.reloc=.text")
#pragma comment(linker, "/merge:.rdata=.text")
#pragma comment(linker, "/merge:.rsrc=.text")
#pragma comment(linker, "/merge:.data=.text")
#pragma comment(linker, "/section:.text,ECIRWP")
#pragma comment(linker, "/ignore:4078") // ignore warning about merged sections

#define PROGRAMNAME "LN - Link creation for Windows NT/2000/XP++ (c) 2005 by -=Assarbad=-\n\n"

typedef enum {
	Hardlink,
	Symlink,
	Force,
	Unlink,
	MaxOptions
};

static BOOL options[MaxOptions] = {TRUE, FALSE, FALSE, FALSE};

BOOL RemoveHardLinkW(LPCWSTR Filename)
{
	if(DWORD dwSize = GetFullPathNameW(Filename, 0, NULL, NULL))
		if(LPWSTR lpwszFullpath = (LPWSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (++dwSize) * sizeof(WCHAR)))
		{
			BOOL result = FALSE;
			if(GetFullPathNameW(Filename, dwSize, lpwszFullpath, NULL))
			{
				result = DeleteFileW(lpwszFullpath);
			}
			HeapFree(GetProcessHeap(), 0, lpwszFullpath);
			return result;
		}
	return FALSE;
}

void ShowError(DWORD dwLastError)
{
	LPWSTR lpBuffer = NULL;

	FormatMessageW(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		dwLastError,
		GetUserDefaultLangID(),
		(LPWSTR)(&lpBuffer),
		0,
		NULL);

	wprintf(L"System error %d:\n%s", dwLastError, lpBuffer);

	if(lpBuffer)
		LocalFree((HLOCAL)lpBuffer);
}

int __cdecl mainW(int argc, LPWSTR *argv)
{
	LPWSTR exe = *argv;
	LPWSTR path1 = NULL, path2 = NULL;
	int p = 0;

	while(argc > 1)
	{
		// Take next parameter (jumps over first)
		LPWSTR arg = *(++argv);
		// Next parameter
		--argc;
		// Check for the contents of the parameter here
		if(!(path1 || path2) && ((arg[0] == L'/') || (arg[0] == L'-')))
		{
			for(unsigned i = 1; i < wcslen(arg); i++)
			{
				CharUpperW(arg);
				switch(arg[i])
				{
				case L'F':
					options[Force] = TRUE;
					break;
				case L'S':
					options[Symlink] = TRUE;
					options[Hardlink] = !options[Symlink];
					break;
				case L'U':
					options[Unlink] = TRUE;
					break;
				}
			}
		}
		else
		{
			// Assign path1 first
			if(!path1)
				path1 = arg;
			else
				// If path1 is assigned, then assign path2
				path2 = arg;

			// With the unlink option set consider only the first path found
			if(options[Unlink] && path1)
				break;
			else
				// Otherwise we need two pathes (<source> <target>)
				if(path1 && path2)
					break;
		}
	}

	// Output some helpful information
	if(!path1 && (!path2 || options[Unlink]))
	{
		wprintf(L"Syntax error! Here's how to use this program.\n\n"
			    L"Usage:\t\tln [options] <source> [<target>]\n"
			    L"Example:\tln -fs .\\SomeSymLink ..\\SomeExistingDirectory\n"
			    L"\nOptions:\n"
			    L"\t/f\t[F]orce linking or unlinking\n"
			    L"\t/s\tCreate or unlink [S]ymbolic link\n"
			    L"\t/u\t[U]nlink <existing file>\n\n"
			    L"Important notes:\n"
			    L"\t- <source> is the link file/directory to be created!\n"
			    L"\t- <target> is the file which exists and to which the link will 'point'.\n"
			    L"\t- <target> will be ignored while unlinking!\n"
			    L"\t- Unlinking a hardlink is no more than deleting it!\n"
			    L"\t- '/f' will be ignored when unlinking hardlinks!\n"
				
				);
		return(-2);
	}

	if(options[Symlink])// && (GetVersion() & 0xFF) < 5)
	{
		ShowError(ERROR_CALL_NOT_IMPLEMENTED);
		return(-3);
	}

	// Proceed after we have all parameters
	if(!options[Unlink])
	{
		// Create link
		if(!options[Symlink])
		{
			if(options[Force])
				RemoveHardLinkW(path1);

			if(CreateHardLinkW(path1, path2, NULL))
				wprintf(L"Successfully created hardlink.\n");
			else
				ShowError(GetLastError());
		}
		else
		{
			ShowError(ERROR_CALL_NOT_IMPLEMENTED);
		}
	}
	else
	{
		// Remove link
		if(!options[Symlink])
		{
			
			if(RemoveHardLinkW(path1))
				wprintf(L"Successfully removed hardlink.\n");
			else
				ShowError(GetLastError());
		}
		else
		{
			ShowError(ERROR_CALL_NOT_IMPLEMENTED);
		}
	}
	return(0);
}

void __cdecl main(void)
{
	printf(PROGRAMNAME);
	if(Hardlink_Initialize())
	{
		int argc;
		LPWSTR* argv = CommandLineToArgvW(GetCommandLineW(), &argc);
		GlobalFree((HGLOBAL)argv);
		ExitProcess(mainW(argc, argv));
	}
	else
	{
		printf("ERROR:\nImportant required functions could not be loaded. This program can only run on Windows NT 4.0 and later. It won't run on Windows 9x/Me!\n");
		ShowError(ERROR_CALL_NOT_IMPLEMENTED);
		ExitProcess(-1);
	}
}
