(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***  LN hardlink creation for NT4/2K/XP/2K3 on NTFS                        ***
 ***                                                                        ***
 ***  Version [2.04b]                               {Last mod 2005-03-06}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2005 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad @ gmx.info|.net|.com|.de  |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizni.    ***
 ***                     Vsekh Privet iz Germanii                           ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 NOTE: This source is OSI-licensed. You may choose between any of the licenses
       approved by the OSI (Open Source Initiative) as long as the licensing
       of this module will not force a whole project under the chosen license.
       This basically means that the virulent character of a license (e.g. GPL)
       must no be misused to force a project to use the license you chose for
       this module!
       OSI-approved licenses can be found at this website:
       http://www.opensource.org/licenses/

       You have the choice to make this module compatible with your own open
       source or commercial or whatever project by choosing the right license.

       However, I recommend using either of the following licenses:
       - the BSD-License (as seen below)
       - the LGPL [ http://www.opensource.org/licenses/lgpl-license.php ]
       - the MPL [ http://www.opensource.org/licenses/mozilla1.1.php ]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2005, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)
program ln;
uses
  Windows,
  Hardlinks in '..\Hardlinks.pas';

{$APPTYPE CONSOLE}
{$R Main.res}

const
  szProgramVersion = 'LN - Hardlink creation on NTFS V2.04a (c) 2001-2004 by -=Assarbad=-'#13#10;
  maxlen = $800;

procedure Help;
// FOREGROUND_BLUE, FOREGROUND_GREEN, FOREGROUND_RED, FOREGROUND_INTENSITY
// BACKGROUND_BLUE, BACKGROUND_GREEN, BACKGROUND_RED, BACKGROUND_INTENSITY
var
  hStdOut: THandle;
begin
  hStdOut := GetStdHandle(STD_OUTPUT_HANDLE);
  Writeln('Directory hardlinks are not possible. Instead it would be possible to have sym-');
  Writeln('linked directories aka Junction/Reparse points. But I do not support this in my');
  Writeln('version of LN.'#13#10);
  Writeln('Syntax:');
  SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN or FOREGROUND_INTENSITY);
  Writeln('  LN <link target> <link name> [/force]');
  Writeln('  LN hardlink?'#13#10);
  SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN or FOREGROUND_BLUE or FOREGROUND_RED);
  Writeln('Meaning:');
  Writeln('  <link target> = the existing file');
  Writeln('  <link name>   = link that points to the existing file');
  Writeln('  [/force]      = (optional) overwrites the <link name>');
  Writeln('  hardlink?     = Shows information "WHAT ARE HARDLINKS?"');
end;

procedure WhatsHardlink;
begin
  Writeln(#13#10 +
    'WHAT ARE HARDLINKS?'#13#10#13#10 +
    'Hardlinks are low level references to one and the same file record (data).'#13#10 +
    'That''s why you can delete any such reference using DEL or a similar function'#13#10 +
    'in the program you use. Unless you delete the last reference to a file record,'#13#10 +
    'the data itself will not be deleted.' + #13#10 +
    'In fact, both the "original file" and any "hardlinks" to it, are hardlinks!'#13#10 +
    'Hardlinks must be on the same volume - they share attributes and security'#13#10 +
    'settings, file stamps and more meta-data.' + #13#10#13#10 +
    '!!! To delete the link, simply delete it as you would do with any file !!!');
end;

procedure OutputCredits;
var
  hStdOut: THandle;
begin
  hStdOut := GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN or FOREGROUND_INTENSITY);
  Writeln(szProgramVersion);
  SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN or FOREGROUND_BLUE or FOREGROUND_RED);
end;

function MAKELANGID(sPrimaryLanguage: Word; sSubLanguage: Word): Word;
begin
  result := (sSubLanguage shl 10) or sPrimaryLanguage;
end;

procedure ShowError1(fname: PWideChar);
var
  c: Cardinal;
  hStdErr: THandle;
  wcsBuf,
    wcsErr: PWideChar;
begin
  hStdErr := GetStdHandle(STD_ERROR_HANDLE);
  if FormatMessageW(
    FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS,
    nil,
    GetLastError,
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
    @wcsErr,
    0,
    nil) <> 0 then
  try
    GetMem(wcsBuf, maxlen);
    if wcsBuf <> nil then
    try
      ZeroMemory(wcsBuf, maxlen);
      lstrcpyW(wcsBuf, 'Error: ');
      lstrcatW(wcsBuf, wcsErr);
      lstrcatW(wcsBuf, #13#10'Link name: ');
      lstrcatW(wcsBuf, fname);
      WriteConsoleW(hStdErr, wcsBuf, lstrlenW(wcsBuf), c, nil);
    finally
      FreeMem(wcsBuf);
    end;
  finally
    LocalFree(THandle(wcsErr));
  end;
end;

procedure ShowSuccess1(fname, target: PWideChar);
var
  c: Cardinal;
  hStdOut: THandle;
  wcsBuf: PWideChar;
begin
  hStdOut := GetStdHandle(STD_OUTPUT_HANDLE);
  GetMem(wcsBuf, maxlen);
  if wcsBuf <> nil then
  try
    ZeroMemory(wcsBuf, maxlen);
    lstrcpyW(wcsBuf, 'Successfully created hardlink.'#13#10#13#10);
    lstrcatW(wcsBuf,       'Link name  : ');
    lstrcatW(wcsBuf, fname);
    lstrcatW(wcsBuf, #13#10'Target name: ');
    lstrcatW(wcsBuf, target);
    WriteConsoleW(hStdOut, wcsBuf, lstrlenW(wcsBuf), c, nil);
  finally
    FreeMem(wcsBuf);
  end;
end;

type
  TWCarr = array[0..0] of PWideChar;
  PWCarr = ^TWCarr;

function CommandLineToArgvW(
  lpCmdLine: PWideChar;
  var NumArgs: Integer
  ): PWCarr; stdcall; external 'shell32.dll';

function Main(argc: Integer; argv: PWCarr): DWORD;
var
  wcsBuf: PWideChar;
  len: Integer;
begin
  OutputCredits;
  case argc of
    2:
      if lstrcmpiW(argv^[argc - 1], 'hardlink?') = 0 then
        WhatsHardlink
      else
        Help;
    3:
// Try to create the hardlink
      if not CreateHardLinkW(argv^[argc - 1], argv^[argc - 2], nil) then
// On error show message with error description
        ShowError1(argv^[argc - 1])
      else
// On success show respective message
        ShowSuccess1(argv^[argc - 1], argv^[argc - 2]);
    4:
      if lstrcmpiW(argv^[argc - 1], '/force') = 0 then
      begin
// Because the user wants to force the action, we'll just Delete the file in
// place for the current link
        if not CreateHardLinkW(argv^[argc - 2], argv^[argc - 3], nil) then
          if GetLastError = ERROR_ALREADY_EXISTS then
          begin
// Get full path name length for the file to delete
            len := (GetFullPathNameW(argv^[argc - 2], 0, nil, PWideChar(nil^)) + 2);
// Allocate buffer
            GetMem(wcsBuf, len shl 1);
            if wcsBuf <> nil then
            try
              ZeroMemory(wcsBuf, len shl 1);
// Actually get full path
              GetFullPathNameW(argv^[argc - 2], len, wcsBuf, PWideChar(nil^));
// Delete the file
              DeleteFileW(wcsBuf);
            finally
// Free the buffer
              FreeMem(wcsbuf);
            end;
// Try to create the hardlink
            if not CreateHardLinkW(argv^[argc - 2], argv^[argc - 3], nil) then
// On error show message with error description
              ShowError1(argv^[argc - 2])
            else
// On success show respective message
              ShowSuccess1(argv^[argc - 2], argv^[argc - 3])
          end;
      end
// TODO: Reparse points for files -> symlinks
      else
// Unknown parameter
        Help;
  else
// Unknown number of parameters
    Help;
  end;
  Result := GetLastError;
end;

var
  arrParams: PWCarr;
  argc: Integer;
begin
  arrParams := CommandLineToArgvW(GetCommandLineW, argc);
  if arrParams <> nil then
  try
    Main(argc, arrParams);
  finally
    GlobalFree(THandle(arrParams));
  end;
end.

